package com.fragments;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Bundle;

import androidx.fragment.app.Fragment;
import com.utils.Utilities;
import android.text.InputType;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.TextPaint;
import android.text.method.LinkMovementMethod;
import android.text.style.ClickableSpan;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.LinearLayout;

import com.countryview.view.CountryPicker;
import com.okbuddy.store.AppLoignRegisterActivity;
import com.okbuddy.store.R;
import com.okbuddy.store.SupportActivity;
import com.dialogs.OpenListView;
import com.general.files.AppFunctions;
import com.general.files.ExecuteWebServerUrl;
import com.general.files.GeneralFunctions;
import com.general.files.MyApp;
import com.general.files.OpenMainProfile;
import com.general.files.PasswordViewHideManager;
import com.general.files.SetOnTouchList;
import com.general.files.SetUserData;
import com.general.files.StartActProcess;
import com.squareup.picasso.Picasso;
import com.utils.Logger;
import com.utils.Utils;
import com.view.GenerateAlertBox;
import com.view.MTextView;
import com.view.editBox.MaterialEditText;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Locale;

/**
 * A simple {@link Fragment} subclass.
 */
public class SignUpFragment extends Fragment {

    static MaterialEditText countryBox;
    static String vCountryCode = "";
    static String vPhoneCode = "";
    static String vSImage = "";
    static boolean isCountrySelected = false;
    View view;
    GenerateAlertBox generateAlert;
    AppLoignRegisterActivity appLoginAct;
    GeneralFunctions generalFunc;
    MaterialEditText companyNameBox;
    MaterialEditText serviceTypeEditBox;
    //MaterialEditText fNameBox;
    //MaterialEditText lNameBox;
    MaterialEditText emailBox;
    MaterialEditText passwordBox;
    MaterialEditText invitecodeBox;
    MaterialEditText mobileBox;

    // SignUpFragment signUpFrag;
    ImageView inviteQueryImg;
    //LinearLayout inviteCodeArea;
    String required_str = "";
    String error_email_str = "";

    MTextView signbootomHint;

    ImageView countrydropimage, countrydropimagerror;
    CheckBox checkboxTermsCond;
    MTextView txtTermsCond;

    String iSelectedServiceId = "0";
    MTextView btnTxt, titleTxt;
    LinearLayout btnArea;
    ImageView btnImg;
    LinearLayout imgClose;
    static ImageView countryimage;
    int iServiceTypePosition = -1;
    int imagewidth;
    int imageheight;
    CountryPicker countryPicker;
    Locale locale;

    public static void setdata(int requestCode, int resultCode, Intent data) {

        if (requestCode == Utils.SELECT_COUNTRY_REQ_CODE && data != null) {

            vCountryCode = data.getStringExtra("vCountryCode");
            vPhoneCode = data.getStringExtra("vPhoneCode");
            isCountrySelected = true;
            vSImage = data.getStringExtra("vSImage");

            Picasso.get().load(vSImage).into(countryimage);

            countryBox.setText("+" + vPhoneCode);
        }

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        view = inflater.inflate(R.layout.fragment_sign_up, container, false);

        appLoginAct = (AppLoignRegisterActivity) getActivity();
        generalFunc = appLoginAct.generalFunc;
        locale = new Locale(generalFunc.retrieveValue(Utils.LANGUAGE_CODE_KEY));
        generateAlert = new GenerateAlertBox(getActContext());
        imagewidth = (int) appLoginAct.getResources().getDimension(R.dimen._30sdp);
        imageheight = (int) appLoginAct.getResources().getDimension(R.dimen._20sdp);

        companyNameBox = (MaterialEditText) view.findViewById(R.id.companyNameBox);
        serviceTypeEditBox = (MaterialEditText) view.findViewById(R.id.serviceTypeEditBox);
        //fNameBox = (MaterialEditText) view.findViewById(R.id.fNameBox);
        //lNameBox = (MaterialEditText) view.findViewById(R.id.lNameBox);
        emailBox = (MaterialEditText) view.findViewById(R.id.emailBox);
        countryBox = (MaterialEditText) view.findViewById(R.id.countryBox);
        mobileBox = (MaterialEditText) view.findViewById(R.id.mobileBox);
        passwordBox = (MaterialEditText) view.findViewById(R.id.passwordBox);
        invitecodeBox = (MaterialEditText) view.findViewById(R.id.invitecodeBox);
        signbootomHint = (MTextView) view.findViewById(R.id.signbootomHint);
        countryimage = view.findViewById(R.id.countryimage);

        countrydropimage = (ImageView) view.findViewById(R.id.countrydropimage);
        countrydropimagerror = (ImageView) view.findViewById(R.id.countrydropimagerror);
        checkboxTermsCond = (CheckBox) view.findViewById(R.id.checkboxTermsCond);
        txtTermsCond = (MTextView) view.findViewById(R.id.txtTermsCond);
        txtTermsCond.setOnClickListener(new setOnClickList());

        vCountryCode = generalFunc.retrieveValue(Utils.DefaultCountryCode);
        vPhoneCode = generalFunc.retrieveValue(Utils.DefaultPhoneCode);
        vSImage = generalFunc.retrieveValue(Utils.DefaultCountryImage);

        if (!vSImage.equals("")) {
            Logger.d("ResizeUrl", "::" + Utilities.getResizeImgURL(getActContext(), vSImage, imagewidth, imageheight));
            Picasso.get().load(Utilities.getResizeImgURL(getActContext(), vSImage, imagewidth, imageheight)).into(countryimage);

        }

        int paddingValStart = (int) getResources().getDimension(R.dimen._35sdp);
        int paddingValEnd = (int) getResources().getDimension(R.dimen._12sdp);
        if (generalFunc.isRTLmode()) {
            countryBox.setPaddings(paddingValEnd, 0, paddingValStart, 0);
            invitecodeBox.setPaddings(paddingValStart, 0, 0, 0);
        } else {
            countryBox.setPaddings(paddingValStart, 0, paddingValEnd, 0);
            invitecodeBox.setPaddings(0, 0, paddingValStart, 0);
        }


        if (!vPhoneCode.equalsIgnoreCase("")) {
            countryBox.setText("+" + vPhoneCode);
            isCountrySelected = true;
        }


        inviteQueryImg = (ImageView) view.findViewById(R.id.inviteQueryImg);

        //inviteCodeArea = (LinearLayout) view.findViewById(R.id.inviteCodeArea);

        inviteQueryImg.setColorFilter(Color.parseColor("#CECECE"));

        inviteQueryImg.setOnClickListener(new setOnClickList());

        //inviteCodeArea.setVisibility(View.GONE);

//        if (generalFunc.isReferralSchemeEnable()) {
//            inviteCodeArea.setVisibility(View.VISIBLE);
//        }

        btnArea = (LinearLayout) view.findViewById(R.id.btnArea);
        btnTxt = (MTextView) view.findViewById(R.id.btnTxt);
        titleTxt = (MTextView) view.findViewById(R.id.titleTxt);

        btnImg = (ImageView) view.findViewById(R.id.btnImg);
        if (generalFunc.isRTLmode()) {
            btnImg.setRotation(180);
            btnArea.setBackground(getActContext().getResources().getDrawable(R.drawable.login_border_rtl));
        }
        btnArea.setOnClickListener(new setOnClickList());

        removeInput();
        setLabels();


        passwordBox.setTypeface(Typeface.DEFAULT);
        passwordBox.setInputType(InputType.TYPE_CLASS_TEXT | InputType.TYPE_TEXT_VARIATION_PASSWORD);
        passwordBox.setTypeface(generalFunc.getDefaultFont(getActContext()));
        mobileBox.setInputType(InputType.TYPE_CLASS_NUMBER);
        emailBox.setInputType(InputType.TYPE_TEXT_VARIATION_EMAIL_ADDRESS | InputType.TYPE_CLASS_TEXT);

        companyNameBox.setImeOptions(EditorInfo.IME_ACTION_NEXT);
        //fNameBox.setImeOptions(EditorInfo.IME_ACTION_NEXT);
        //lNameBox.setImeOptions(EditorInfo.IME_ACTION_NEXT);
        emailBox.setImeOptions(EditorInfo.IME_ACTION_NEXT);
        passwordBox.setImeOptions(EditorInfo.IME_ACTION_NEXT);
        mobileBox.setImeOptions(EditorInfo.IME_ACTION_DONE);

        passwordBox.setTypeface(generalFunc.getDefaultFont(getActContext()));

        new PasswordViewHideManager(getActContext(), passwordBox, generalFunc);
        countryBox.setShowClearButton(false);
        imgClose = (LinearLayout) view.findViewById(R.id.imgClose);
        imgClose.setOnClickListener(new setOnClickList());

        checkServiceTypeArea();
//        buildLanguageList();

        return view;
    }

    public void removeInput() {
        Utils.removeInput(countryBox);
        Utils.removeInput(serviceTypeEditBox);

        if (generalFunc.retrieveValue("showCountryList").equalsIgnoreCase("Yes")) {
            countrydropimage.setVisibility(View.VISIBLE);

            countryBox.setOnTouchListener(new SetOnTouchList());
            countryBox.setOnClickListener(new setOnClickList());
        }

        serviceTypeEditBox.setOnTouchListener(new SetOnTouchList());

        serviceTypeEditBox.setOnClickListener(new setOnClickList());
    }

    public void setLabels() {

        serviceTypeEditBox.setBothText(generalFunc.retrieveLangLBl("Service Type", "LBL_SERVICES_TYPE"), generalFunc.retrieveLangLBl("", "LBL_SELECT_SERVICE_TYPE"));
        companyNameBox.setBothText(generalFunc.retrieveLangLBl("Store Name", "LBL_STORE_NAME"));
        //fNameBox.setBothText(generalFunc.retrieveLangLBl("First Name", "LBL_FIRST_NAME_HEADER_TXT"));
        //lNameBox.setBothText(generalFunc.retrieveLangLBl("Last Name", "LBL_LAST_NAME_HEADER_TXT"));


        signbootomHint.setText(generalFunc.retrieveLangLBl("Already have an account ?", "LBL_ALREADY_HAVE_ACC"));


        emailBox.setBothText(generalFunc.retrieveLangLBl("", "LBL_EMAIL_LBL_TXT"));
        countryBox.setBothText(generalFunc.retrieveLangLBl("", "LBL_COUNTRY_TXT"));
        mobileBox.setBothText(generalFunc.retrieveLangLBl("", "LBL_MOBILE_NUMBER_HEADER_TXT"));
        passwordBox.setBothText(generalFunc.retrieveLangLBl("", "LBL_PASSWORD_LBL_TXT"));

        btnTxt.setText(generalFunc.retrieveLangLBl("", "LBL_SIGNUP"));
        titleTxt.setText(generalFunc.retrieveLangLBl("", "LBL_SIGNUP"));
        signbootomHint.setText(generalFunc.retrieveLangLBl("", "LBL_ALREADY_HAVE_ACC"));


        required_str = generalFunc.retrieveLangLBl("Required", "LBL_FEILD_REQUIRD");
        error_email_str = generalFunc.retrieveLangLBl("Email Required", "LBL_FEILD_EMAIL_ERROR_TXT");

        String attrString1 = generalFunc.retrieveLangLBl("I agree to the terms & Conditions and", "LBL_TERMS_CONDITION_PREFIX");
        String attrString2 = generalFunc.retrieveLangLBl("Privacy Policy", "LBL_TERMS_PRIVACY");

        String htmlString = "<u><font color=" + getActContext().getResources().getColor(R.color.appThemeColor_1) + ">" + attrString2 + "</font></u>";
        txtTermsCond.setText(AppFunctions.fromHtml(attrString1 + " " + htmlString));

        invitecodeBox.setBothText(generalFunc.retrieveLangLBl("Referral/ Invite Code (Optional)", "LBL_INVITE_CODE_HINT"), generalFunc.retrieveLangLBl("Referral/ Invite Code (Optional)", "LBL_INVITE_CODE_HINT"));
        required_str = generalFunc.retrieveLangLBl("", "LBL_FEILD_REQUIRD");
        error_email_str = generalFunc.retrieveLangLBl("", "LBL_FEILD_EMAIL_ERROR");

        invitecodeBox.setBothText(generalFunc.retrieveLangLBl("", "LBL_REFERRAL_CODE_HINT"), generalFunc.retrieveLangLBl("", "LBL_REFERRAL_CODE_HINT"));


        String termsfirstVal = generalFunc.retrieveLangLBl("", "LBL_TERMS_CONDITION_PREFIX_TXT");
        String termsSecondVal = generalFunc.retrieveLangLBl("", "LBL_TERMS_CONDITION");
        String termsThirdVal = generalFunc.retrieveLangLBl("", "LBL_TERMS_CONDITION_POSTFIX_TXT");
        String termsVal = termsfirstVal + " " + termsSecondVal + " " + termsThirdVal;
        manageSpanView(termsVal, termsSecondVal, txtTermsCond);

        String signupFirstVal = generalFunc.retrieveLangLBl("", "LBL_ALREADY_HAVE_ACC");
//        String signupSecondVal = generalFunc.retrieveLangLBl("", "LBL_SIGN_IN");
        String signupSecondVal = generalFunc.retrieveLangLBl("", "LBL_HEADER_TOPBAR_SIGN_IN_TXT");
        String signupThirdVal = generalFunc.retrieveLangLBl("", "LBL_NOW");
        String signupfinalVal = signupFirstVal + " " + signupSecondVal + " " + signupThirdVal;

        manageSpanView(signupfinalVal, signupSecondVal, signbootomHint);

        configServiceData();
    }


    public void manageSpanView(String finalString, String clickAbleString, MTextView txtView) {
        String firstVal = generalFunc.retrieveLangLBl("", "LBL_TERMS_CONDITION_PREFIX_TXT");
        String secondVal = generalFunc.retrieveLangLBl("", "LBL_TERMS_CONDITION");
        String thirdVal = generalFunc.retrieveLangLBl("", "LBL_TERMS_CONDITION_POSTFIX_TXT");
        String finalVal = firstVal + " " + secondVal + " " + thirdVal;
        SpannableString termsSpan = new SpannableString(finalString);


        termsSpan.setSpan(
                ClickableSpan, // Span to add
                finalString.indexOf(clickAbleString), // Start of the span (inclusive)
                finalString.indexOf(clickAbleString) + String.valueOf(clickAbleString).length(), // End of the span (exclusive)
                Spanned.SPAN_EXCLUSIVE_EXCLUSIVE // Do not extend the span when text add later
        );
        txtView.setText(termsSpan);
        txtView.setMovementMethod(LinkMovementMethod.getInstance());
    }

    public void checkServiceTypeArea() {
        String serviceDataStr = generalFunc.retrieveValue(Utils.serviceCategoriesKey);
        JSONArray serviceDataArr = generalFunc.getJsonArray(serviceDataStr);

        if (serviceDataArr != null) {
            if (serviceDataArr.length() == 1) {
                (view.findViewById(R.id.serviceTypeSelectArea)).setVisibility(View.GONE);
            } else {

                (view.findViewById(R.id.serviceTypeSelectArea)).setVisibility(View.VISIBLE);
            }
        }
    }

    ClickableSpan ClickableSpan = new ClickableSpan() {
        @Override
        public void onClick(View view) {

            if (view == txtTermsCond) {
                Bundle bn = new Bundle();
                bn.putBoolean("islogin", true);
                new StartActProcess(getActContext()).startActWithData(SupportActivity.class, bn);
            } else if (view == signbootomHint) {
                if (!appLoginAct.isSignInFirst) {
                    appLoginAct.signUpFragment=null;
                    appLoginAct.handleFragment(new SignInFragment(), true, false);
                } else {
                    appLoginAct.signUpFragment=null;
                    appLoginAct.handleFragment(new SignInFragment(), false, false);
                }
                appLoginAct.signheaderHint.setText(generalFunc.retrieveLangLBl("", "LBL_SIGN_IN_WITH_SOC_ACC_HINT"));

            }

        }

        @Override
        public void updateDrawState(TextPaint ds) {
            ds.setColor(getResources().getColor(R.color.appThemeColor_1));    // you can use custom color
            ds.setUnderlineText(false);    // this remove the underline
        }
    };

    public ArrayList<HashMap<String, String>> configServiceData() {
        String serviceDataStr = generalFunc.retrieveValue(Utils.serviceCategoriesKey);
        JSONArray serviceDataArr = generalFunc.getJsonArray(serviceDataStr);

        ArrayList<HashMap<String, String>> serviceDataList = new ArrayList<>();
        if (serviceDataArr != null) {

            boolean setInitialValue = false;
            if (serviceDataArr.length() == 1) {
                (view.findViewById(R.id.serviceTypeSelectArea)).setVisibility(View.GONE);
                setInitialValue = true;
            }

            for (int i = 0; i < serviceDataArr.length(); i++) {
                JSONObject obj_tmp = generalFunc.getJsonObject(serviceDataArr, i);

                HashMap<String, String> mapData = new HashMap<>();
                mapData.put("vServiceName", generalFunc.getJsonValueStr("vServiceName", obj_tmp));
                mapData.put("iServiceId", generalFunc.getJsonValueStr("iServiceId", obj_tmp));

                serviceDataList.add(mapData);

                if (setInitialValue) {
                    iSelectedServiceId = generalFunc.getJsonValueStr("iServiceId", obj_tmp);
                }
            }
        }

        return serviceDataList;
    }

    public void buildServiceData() {


        /*GenerateAlertBox generateAlertBox = new GenerateAlertBox(getActContext());

        generateAlertBox.setContentMessage(generalFunc.retrieveLangLBl("", "LBL_SELECT_SERVICE_TYPE"), null);
        generateAlertBox.setCancelable(true);
        generateAlertBox.createList(configServiceData(), "vServiceName", (position) -> {

            generateAlertBox.closeAlertBox();

            HashMap<String, String> mapData = configServiceData().get(position);

            iSelectedServiceId = mapData.get("iServiceId");

            serviceTypeEditBox.setText(mapData.get("vServiceName"));


        });

        generateAlertBox.showAlertBox();*/


        OpenListView.getInstance(getActContext(), generalFunc.retrieveLangLBl("", "LBL_SELECT_SERVICE_TYPE"), configServiceData(), OpenListView.OpenDirection.CENTER, true, position -> {

            iServiceTypePosition = position;

            HashMap<String, String> mapData = configServiceData().get(position);

            iSelectedServiceId = mapData.get("iServiceId");

            serviceTypeEditBox.setText(mapData.get("vServiceName"));

        }).show(iServiceTypePosition, "vServiceName");

    }

    public void checkData() {
        Utils.hideKeyboard(getActContext());

        String noWhiteSpace = generalFunc.retrieveLangLBl("Password should not contain whitespace.", "LBL_ERROR_NO_SPACE_IN_PASS");
        String pass_length = generalFunc.retrieveLangLBl("Password must be", "LBL_ERROR_PASS_LENGTH_PREFIX")
                + " " + Utils.minPasswordLength + " " + generalFunc.retrieveLangLBl("or more character long.", "LBL_ERROR_PASS_LENGTH_SUFFIX");

        boolean cNameEntered = Utils.checkText(companyNameBox) ? true : Utils.setErrorFields(companyNameBox, required_str);
        //boolean fNameEntered = Utils.checkText(fNameBox) ? true : Utils.setErrorFields(fNameBox, required_str);
        //boolean lNameEntered = Utils.checkText(lNameBox) ? true : Utils.setErrorFields(lNameBox, required_str);
        boolean isEmailBlankAndOptional = new AppFunctions(getActContext()).isEmailBlankAndOptional(generalFunc, Utils.getText(emailBox));
        boolean emailEntered = isEmailBlankAndOptional?true:(Utils.checkText(emailBox) ?
                (generalFunc.isEmailValid(Utils.getText(emailBox)) ? true : Utils.setErrorFields(emailBox, error_email_str))
                : Utils.setErrorFields(emailBox, required_str));
        boolean mobileEntered = Utils.checkText(mobileBox) ? true : Utils.setErrorFields(mobileBox, required_str);
        boolean countryEntered = isCountrySelected ? true : false;
        boolean passwordEntered = Utils.checkText(passwordBox) ?
                (Utils.getText(passwordBox).contains(" ") ? Utils.setErrorFields(passwordBox, noWhiteSpace)
                        : (Utils.getText(passwordBox).length() >= Utils.minPasswordLength ? true : Utils.setErrorFields(passwordBox, pass_length)))
                : Utils.setErrorFields(passwordBox, required_str);

        if (countryBox.getText().length() == 0) {
            countryEntered = false;
        }

        if (generalFunc.retrieveValue("showCountryList").equalsIgnoreCase("Yes")) {

            if (!countryEntered) {
                Utils.setErrorFields(countryBox, required_str);
                countrydropimagerror.setVisibility(View.VISIBLE);
                countrydropimage.setVisibility(View.GONE);
            } else {
                countrydropimage.setVisibility(View.VISIBLE);
                countrydropimagerror.setVisibility(View.GONE);
            }
        }

        if (mobileEntered) {
            mobileEntered = mobileBox.length() >= 3 ? true : Utils.setErrorFields(mobileBox, generalFunc.retrieveLangLBl("", "LBL_INVALID_MOBILE_NO"));
        }

        if (iSelectedServiceId.equals("") || iSelectedServiceId.equalsIgnoreCase("0")) {
            generalFunc.showMessage(generalFunc.getCurrentView((Activity) getActContext()), generalFunc.retrieveLangLBl("", "LBL_SELECT_SERVICE_TYPE_NOTE"));
        }

        if (cNameEntered == false || /*fNameEntered == false ||*/ /*lNameEntered == false ||*/ emailEntered == false || mobileEntered == false
                || countryEntered == false || passwordEntered == false || iSelectedServiceId.equals("") || iSelectedServiceId.equalsIgnoreCase("0")) {
            return;
        }




        /*if (generalFunc.retrieveValue(Utils.MOBILE_VERIFICATION_ENABLE_KEY).equals("Yes")) {
            checkUserExist();
        } else*/

        registerUser();

    }


    public void registerUser() {
        HashMap<String, String> parameters = new HashMap<String, String>();
        parameters.put("type", "signup_company");
        parameters.put("vCompany", Utils.getText(companyNameBox));
        parameters.put("vEmail", Utils.getText(emailBox));
        parameters.put("vPhone", Utils.getText(mobileBox));
        parameters.put("vPassword", Utils.getText(passwordBox));
        parameters.put("PhoneCode", vPhoneCode);
        parameters.put("CountryCode", vCountryCode);
        parameters.put("vCurrency", generalFunc.retrieveValue(Utils.DEFAULT_CURRENCY_VALUE));
        parameters.put("vLang", generalFunc.retrieveValue(Utils.LANGUAGE_CODE_KEY));
        parameters.put("UserType", Utils.userType);
        parameters.put("vDeviceType", Utils.deviceType);
        parameters.put("iServiceId", iSelectedServiceId);

        //parameters.put("vFirstName", Utils.getText(fNameBox));
        //parameters.put("vLastName", Utils.getText(lNameBox));
        //parameters.put("vEmail", Utils.getText(emailBox));
        //parameters.put("vPhone", Utils.getText(mobileBox));
        //parameters.put("vPassword", Utils.getText(passwordBox));
        //parameters.put("PhoneCode", vPhoneCode);
        //parameters.put("CountryCode", vCountryCode);
        //parameters.put("vDeviceType", Utils.deviceType);
        //parameters.put("vInviteCode", Utils.getText(invitecodeBox));
        //parameters.put("UserType", Utils.userType);
        //parameters.put("vCurrency", generalFunc.retrieveValue(Utils.DEFAULT_CURRENCY_VALUE));
        //parameters.put("vLang", generalFunc.retrieveValue(Utils.LANGUAGE_CODE_KEY));


        ExecuteWebServerUrl exeWebServer = new ExecuteWebServerUrl(getActContext(), parameters);
        exeWebServer.setLoaderConfig(getActContext(), true, generalFunc);
        exeWebServer.setIsDeviceTokenGenerate(true, "vDeviceToken", generalFunc);
        exeWebServer.setDataResponseListener(responseString -> {

            JSONObject responseObj = generalFunc.getJsonObject(responseString);
            if (responseObj != null && !responseObj.equals("")) {

                boolean isDataAvail = GeneralFunctions.checkDataAvail(Utils.action_str, responseObj);

                if (isDataAvail == true) {
                    new SetUserData(responseString, generalFunc, getActContext(), true);

                    appLoginAct.manageSinchClient();
                    generalFunc.storeData(Utils.USER_PROFILE_JSON, generalFunc.getJsonValueStr(Utils.message_str, responseObj));
                    new OpenMainProfile(getActContext(),
                            generalFunc.getJsonValueStr(Utils.message_str, responseObj), false, generalFunc).startProcess();
                } else {
                    generalFunc.showGeneralMessage("",
                            generalFunc.retrieveLangLBl("", generalFunc.getJsonValueStr(Utils.message_str, responseObj)));
                }
            } else {
                generalFunc.showError();
            }
        });
        exeWebServer.execute();
    }

    public void checkUserExist() {
        HashMap<String, String> parameters = new HashMap<String, String>();
        parameters.put("type", "isUserExist");
        parameters.put("Email", Utils.getText(emailBox));
        parameters.put("Phone", Utils.getText(mobileBox));

        ExecuteWebServerUrl exeWebServer = new ExecuteWebServerUrl(getActContext(), parameters);
        exeWebServer.setLoaderConfig(getActContext(), true, generalFunc);
        exeWebServer.setDataResponseListener(responseString -> {


            JSONObject responseObj = generalFunc.getJsonObject(responseString);
            if (responseObj != null && !responseObj.equals("")) {

                boolean isDataAvail = GeneralFunctions.checkDataAvail(Utils.action_str, responseObj);

                if (isDataAvail == true) {
                    notifyVerifyMobile();
                } else {
                    generalFunc.showGeneralMessage("",
                            generalFunc.retrieveLangLBl("", generalFunc.getJsonValueStr(Utils.message_str, responseObj)));
                }
            } else {
                generalFunc.showError();
            }
        });
        exeWebServer.execute();
    }

    public void notifyVerifyMobile() {
        Bundle bn = new Bundle();
        bn.putString("MOBILE", vPhoneCode + Utils.getText(mobileBox));
        bn.putString("msg", "DO_PHONE_VERIFY");
        // generalFunc.verifyMobile(bn, signUpFrag);
    }

    public Context getActContext() {
        return appLoginAct.getActContext();
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if (requestCode == Utils.SELECT_COUNTRY_REQ_CODE && resultCode == appLoginAct.RESULT_OK && data != null) {

            vCountryCode = data.getStringExtra("vCountryCode");
            vPhoneCode = data.getStringExtra("vPhoneCode");
            vSImage = data.getStringExtra("vSImage");
            Log.d("TestData", "::" + vSImage);
            Picasso.get().load(Utilities.getResizeImgURL(getActContext(), vSImage, imagewidth, imageheight)).into(countryimage);
            isCountrySelected = true;
            countryBox.setTextColor(getResources().getColor(R.color.black));
        } else if (requestCode == Utils.VERIFY_MOBILE_REQ_CODE && resultCode == appLoginAct.RESULT_OK) {
            String MSG_TYPE = data == null ? "" : (data.getStringExtra("MSG_TYPE") == null ? "" : data.getStringExtra("MSG_TYPE"));
            if (!MSG_TYPE.equals("EDIT_PROFILE")) {
                registerUser();
            }
        }
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        Utils.hideKeyboard(getActivity());
    }

    public void setData(String vCountryCode, String vPhoneCode, String vSImage) {
        this.vCountryCode = vCountryCode;
        this.vPhoneCode = vPhoneCode;
        isCountrySelected = true;
        this.vSImage = vSImage;

        Picasso.get().load(vSImage).into(countryimage);

        GeneralFunctions generalFunctions = new GeneralFunctions(MyApp.getInstance().getCurrentAct());
        countryBox.setText("+" + generalFunctions.convertNumberWithRTL(vPhoneCode));
    }
    public class setOnClickList implements View.OnClickListener {

        @Override
        public void onClick(View view) {

            if (!isAdded()) {
                return;
            }
            Utils.hideKeyboard(getActivity());
            int i = view.getId();
            if (i == btnArea.getId()) {
                checkData();
            } else if (i == R.id.countryBox) {
                //  new StartActProcess(getActivity()).startActForResult(SelectCountryActivity.class, Utils.SELECT_COUNTRY_REQ_CODE);
                if (countryPicker == null) {
                    countryPicker = new CountryPicker.Builder(getActContext()).showingDialCode(true)
                            .setLocale(locale).showingFlag(true)
                            .enablingSearch(true)
                            //.setCountries(items_list)
                            .setCountrySelectionListener(country -> setData(country.getCode(), country.getDialCode(), country.getFlagName()))
                            .build();
                }
                countryPicker.show(getActContext());


            } else if (i == inviteQueryImg.getId()) {
                generalFunc.showGeneralMessage(generalFunc.retrieveLangLBl(" What is Referral / Invite Code ?", "LBL_REFERAL_SCHEME_TXT"),
                        generalFunc.retrieveLangLBl("", "LBL_REFERAL_SCHEME"));

            } else if (i == R.id.serviceTypeEditBox) {
                buildServiceData();
            } else if (i == imgClose.getId()) {
                appLoginAct.onBackPressed();
            }


        }


    }

}