package com.general.files;

import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;

import com.okbuddy.store.BuildConfig;
import com.google.gson.Gson;
import com.rest.RestClient;
import com.utils.CommonUtilities;
import com.utils.DeviceData;
import com.utils.Logger;
import com.utils.Utils;
import com.view.MyProgressDialog;

import java.util.HashMap;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * Created by Admin on 22-02-2016.
 */
public class ExecuteWebServerUrl {
    public static String CUSTOM_APP_TYPE = "";
    SetDataResponse setDataRes;

    HashMap<String, String> parameters;

    GeneralFunctions generalFunc;

    String responseString = "";

    boolean directUrl_value = false;
    String directUrl = "";

    boolean isLoaderShown = false;
    Context mContext;

    MyProgressDialog myPDialog;

    boolean isGenerateDeviceToken = false;
    String key_DeviceToken_param;
    InternetConnection intCheck;

    boolean isTaskKilled = false;

    Call<Object> currentCall;
    public static String MAPS_API_REPLACEMENT_STRATEGY = "None";
    HashMap<String, Object> parameters1;
    boolean isObjectTypeParam = false;

    public ExecuteWebServerUrl(Context mContext, HashMap<String, String> parameters) {
        this.parameters = parameters;
        this.mContext = mContext;
    }

    public ExecuteWebServerUrl(Context mContext, String directUrl, boolean directUrl_value) {
        this.directUrl = directUrl;
        this.directUrl_value = directUrl_value;
        this.mContext = mContext;

        if (directUrl.startsWith("https://maps.googleapis.com") && MAPS_API_REPLACEMENT_STRATEGY.equalsIgnoreCase("Normal")) {
            parameters = new HashMap<String, String>();
            parameters.put("type", "fetchAPIDetails");
            parameters.put("API_URL", directUrl);
        }
    }

    public ExecuteWebServerUrl(Context mContext, HashMap<String, Object> parameters1, boolean isObjectTypeParam) {
        this.parameters1 = parameters1;
        this.mContext = mContext;
        this.isObjectTypeParam = isObjectTypeParam;
    }


    public void setLoaderConfig(Context mContext, boolean isLoaderShown, GeneralFunctions generalFunc) {
        this.isLoaderShown = isLoaderShown;
        this.generalFunc = generalFunc;
        this.mContext = mContext;
    }


    public void setIsDeviceTokenGenerate(boolean isGenerateDeviceToken, String key_DeviceToken_param, GeneralFunctions generalFunc) {
        this.isGenerateDeviceToken = isGenerateDeviceToken;
        this.key_DeviceToken_param = key_DeviceToken_param;
        this.generalFunc = generalFunc;
    }

//    public void setCancelAble(boolean isSetCancelable) {
//        this.isSetCancelable = isSetCancelable;
//    }

    public void execute() {
        Utils.runGC();
        intCheck = new InternetConnection(mContext);

        if (!intCheck.isNetworkConnected() && !intCheck.check_int()) {
            fireResponse();
            return;
        }

        if (isLoaderShown == true) {
            myPDialog = new MyProgressDialog(mContext, false, generalFunc.retrieveLangLBl("Loading", "LBL_LOADING_TXT"));
//            isSetCancelable = true;
            try {
                myPDialog.show();
            } catch (Exception e) {

            }
        }

        if (parameters1 != null) {
            GeneralFunctions generalFunc = MyApp.getInstance().getAppLevelGeneralFunc();
            parameters1.put("tSessionId", generalFunc.getMemberId().equals("") ? "" : generalFunc.retrieveValue(Utils.SESSION_ID_KEY));
            parameters1.put("deviceHeight", Utils.getScreenPixelHeight(mContext) + "");
            parameters1.put("deviceWidth", Utils.getScreenPixelWidth(mContext) + "");
            parameters1.put("GeneralUserType", Utils.app_type);
            parameters1.put("GeneralMemberId", generalFunc.getMemberId());
            parameters1.put("iServiceId", parameters1.get("iServiceId") == null ? generalFunc.getServiceId() : parameters1.get("iServiceId"));
            parameters1.put("GeneralDeviceType", "" + Utils.deviceType);
            parameters1.put("GeneralAppVersion", BuildConfig.VERSION_NAME);
            parameters1.put("GeneralAppVersionCode", "" + BuildConfig.VERSION_CODE);
            parameters1.put("vTimeZone", generalFunc.getTimezone());
            parameters1.put("vUserDeviceCountry", Utils.getUserDeviceCountryCode(mContext));
            parameters1.put("vGeneralLang", generalFunc.retrieveValue(Utils.LANGUAGE_CODE_KEY));

            try {
                if (parameters1.get("type") != null && (parameters1.get("type").toString().equalsIgnoreCase("getDetail") || parameters1.get("type").toString().equalsIgnoreCase("signIn") || parameters1.get("type").toString().equalsIgnoreCase("signup") || parameters1.get("type").toString().equalsIgnoreCase("LoginWithFB"))) {
                    parameters1.put("DEVICE_DATA", DeviceData.getDeviceData());
                }
            } catch (Exception e) {

            }

            try {
                if (parameters1.get("type") != null && parameters1.get("type").toString().equalsIgnoreCase("generalConfigData")) {
                    parameters1.putAll(GetFeatureClassList.getAllGeneralClasses());
                }
            } catch (Exception e) {

            }
        }else if (parameters != null) {
            GeneralFunctions generalFunc = MyApp.getInstance().getAppLevelGeneralFunc();
            parameters.put("tSessionId", generalFunc.getMemberId().equals("") ? "" : generalFunc.retrieveValue(Utils.SESSION_ID_KEY));
            parameters.put("deviceHeight", Utils.getScreenPixelHeight(mContext) + "");
            parameters.put("deviceWidth", Utils.getScreenPixelWidth(mContext) + "");
            parameters.put("GeneralUserType", Utils.app_type);
            parameters.put("GeneralMemberId", generalFunc.getMemberId());
            parameters.put("iServiceId", parameters.get("iServiceId") == null ? generalFunc.getServiceId() : parameters.get("iServiceId"));
            parameters.put("GeneralDeviceType", "" + Utils.deviceType);
            parameters.put("GeneralAppVersion", BuildConfig.VERSION_NAME);
            parameters.put("GeneralAppVersionCode", "" + BuildConfig.VERSION_CODE);
            parameters.put("vTimeZone", generalFunc.getTimezone());
            parameters.put("vUserDeviceCountry", Utils.getUserDeviceCountryCode(mContext));
            parameters.put("vGeneralLang", generalFunc.retrieveValue(Utils.LANGUAGE_CODE_KEY));

            try {
                if (parameters.get("type") != null && (parameters.get("type").equalsIgnoreCase("getDetail") || parameters.get("type").equalsIgnoreCase("signIn") || parameters.get("type").equalsIgnoreCase("signup") || parameters.get("type").equalsIgnoreCase("LoginWithFB"))) {
                    parameters.put("DEVICE_DATA", DeviceData.getDeviceData());
                }
            } catch (Exception e) {

            }

            try {
                if (parameters.get("type") != null && parameters.get("type").equalsIgnoreCase("generalConfigData")) {
                    parameters.putAll(GetFeatureClassList.getAllGeneralClasses());
                }
            } catch (Exception e) {

            }
        }

        if (generalFunc != null) {
            GetDeviceToken getDeviceToken = new GetDeviceToken(generalFunc);

            getDeviceToken.setDataResponseListener(vDeviceToken -> {

                if (isGenerateDeviceToken) {
                    if (!vDeviceToken.equals("")) {

                        if (parameters != null) {
                            parameters.put(key_DeviceToken_param, "" + vDeviceToken);
                            parameters.put("vFirebaseDeviceToken", vDeviceToken);
                        }
                        performPostCall();
                    } else {
                        responseString = "";
                        fireResponse();
                    }
                } else {

                    if (parameters != null) {
                        parameters.put("vFirebaseDeviceToken", vDeviceToken);
                    }
                    performPostCall();

                }

            });
            getDeviceToken.execute();

        } else {
            performPostCall();
        }
    }

    public void performGetCall(String directUrl) {
        Call<Object> call = RestClient.getClient("GET",CommonUtilities.SERVER).getResponse(directUrl);

        currentCall = call;
        call.enqueue(new Callback<Object>() {

            @Override
            public void onResponse(Call<Object> call, Response<Object> response) {
                if (response.isSuccessful()) {

                    responseString = RestClient.getGSONBuilder().toJson(response.body());

                    fireResponse();
                } else {
                    if (response.errorBody() != null) {
                        try {
                            responseString = RestClient.getGSONBuilder().toJson(response.errorBody().string());
                        } catch (Exception e) {
                            responseString = "";
                        }
                    } else {
                        responseString = "";
                    }
                    fireResponse();
                }
            }

            @Override
            public void onFailure(Call<Object> call, Throwable t) {
                Logger.d("DataError", "::" + t.getMessage());
                responseString = "";
                fireResponse();
            }

        });
    }

    public void performPostCall() {
        if (directUrl_value && (!directUrl.startsWith("https://maps.googleapis.com") || (directUrl.startsWith("https://maps.googleapis.com") && !MAPS_API_REPLACEMENT_STRATEGY.equalsIgnoreCase("Normal")))) {
            performGetCall(directUrl);
            return;
        }
        Call<Object> call;
        if (isObjectTypeParam && parameters1 != null) {
            call = RestClient.getClient("POST",CommonUtilities.SERVER, mContext).getResponseObj(CommonUtilities.SERVER_WEBSERVICE_PATH,parameters1);
        } else {
            call = RestClient.getClient("POST",CommonUtilities.SERVER, mContext).getResponse(CommonUtilities.SERVER_WEBSERVICE_PATH,parameters);
        }

        currentCall = call;
        call.enqueue(new Callback<Object>() {
            @Override
            public void onResponse(Call<Object> call, Response<Object> response) {
                Logger.d("Data", "response = " + new Gson().toJson(response.body()));
                if (response.isSuccessful()) {
                    // request successful (status code 200, 201)


                    responseString = RestClient.getGSONBuilder().toJson(response.body());

                    fireResponse();
                } else {
                    if (response.errorBody() != null) {
                        try {
                            responseString = RestClient.getGSONBuilder().toJson(response.errorBody().string());
                        } catch (Exception e) {
                            responseString = "";
                        }
                    } else {
                        responseString = "";
                    }
                    fireResponse();
                }
            }

            @Override
            public void onFailure(Call<Object> call, Throwable t) {
                Logger.d("DataError", "::" + t.getMessage());
                responseString = "";
                fireResponse();
            }

        });
    }


    public void fireResponse() {
        if (myPDialog != null) {
            myPDialog.close();
        }

        if (setDataRes != null && isTaskKilled == false) {

            GeneralFunctions generalFunc = MyApp.getInstance().getAppLevelGeneralFunc();
            String message = Utils.checkText(responseString) ? generalFunc.getJsonValue(Utils.message_str, responseString) : null;

            if (message != null && message.equals("DO_RESTART")) {
                generalFunc.restartApp();
                Utils.runGC();
                return;
            } else {
                try {


                    if (mContext != null && mContext instanceof Activity) {
                        Activity act = (Activity) mContext;
                        if (!act.isFinishing()) {
                            if (message != null && message.equals("SESSION_OUT")) {
                                MyApp.getInstance().notifySessionTimeOut();
                                Utils.runGC();
                                return;
                            }

                        }
                    }


                } catch (Exception e) {

                }

             /*   if (directUrl.startsWith("https://maps.googleapis.com") && MAPS_API_REPLACEMENT_STRATEGY.equalsIgnoreCase("Normal")) {

                    responseString = generalFunc.getJsonValue("DATA_RESULT", responseString);
                }*/

                setDataRes.setResponse(responseString);
            }
        }
    }

    public void cancel(boolean value) {

        this.isTaskKilled = value;
        if (currentCall != null) {

            new AsyncTask<String, String, String>() {
                @Override
                protected String doInBackground(String... params) {
                    currentCall.cancel();
                    return "";
                }
            }.execute();
        }
    }


    public void setDataResponseListener(SetDataResponse setDataRes) {
        this.setDataRes = setDataRes;
    }

    public interface SetDataResponse {
        void setResponse(String responseString);
    }
}
