/*
package com.okbuddy.store;

import android.os.Bundle;
import android.widget.ListView;
import android.widget.ArrayAdapter;
import android.widget.Toast;
import android.os.AsyncTask;
import java.util.List;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import org.json.JSONArray;
import org.json.JSONObject;
import java.util.ArrayList;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

public class ManageQRActivity extends AppCompatActivity {
    private RecyclerView qrRecyclerView;
    private List<QRCodeModel> qrCodes;
    private QRCodeAdapter adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_manage_qr);

        qrRecyclerView = findViewById(R.id.qr_recycler_view);

        qrCodes = new ArrayList<>();
        adapter = new QRCodeAdapter(qrCodes);
        qrRecyclerView.setLayoutManager(new LinearLayoutManager(this));
        qrRecyclerView.setAdapter(adapter);

        loadQRCodes();
    }

    private void loadQRCodes() {
        new FetchQRCodesTask().execute("http://yourdomain.com/get_qr_codes.php?iCompanyId=1");
    }

    private class FetchQRCodesTask extends AsyncTask<String, Void, String> {
        @Override
        protected String doInBackground(String... urls) {
            StringBuilder response = new StringBuilder();
            try {
                URL url = new URL(urls[0]);
                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
                String line;
                while ((line = br.readLine()) != null) {
                    response.append(line);
                }
                br.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return response.toString();
        }

        @Override
        protected void onPostExecute(String result) {
            try {
                JSONArray jsonArray = new JSONArray(result);
                for (int i = 0; i < jsonArray.length(); i++) {
                    JSONObject jsonObject = jsonArray.getJSONObject(i);
                    QRCodeModel qrCodeModel = new QRCodeModel();
                    qrCodeModel.setId(jsonObject.getInt("id"));
                    qrCodeModel.setICompanyId(jsonObject.getInt("iCompanyId"));
                    qrCodeModel.setTableName(jsonObject.getString("TableName"));
                    qrCodeModel.setItemsIds(jsonObject.getString("items_ids"));
                    qrCodes.add(qrCodeModel);
                }
                adapter.notifyDataSetChanged();
            } catch (Exception e) {
                e.printStackTrace();
                Toast.makeText(ManageQRActivity.this, "Error loading QR Codes", Toast.LENGTH_SHORT).show();
            }
        }
    }
}
*/
