package com.okbuddy.store;

import android.content.ContentValues;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PorterDuff;
import android.graphics.PorterDuffXfermode;
import android.graphics.Rect;
import android.graphics.RectF;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.FragmentManager;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.fragments.Itemfragment;
import com.general.files.GeneralFunctions;
import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.FirebaseApp;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;
import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

/*public class QRMenuActivity extends AppCompatActivity {
    private EditText tableNumberInput;
    private Button saveQrCodeButton;
    private Button addAllItemsButton;
    private ImageView qrCodeImageView;
    private Itemfragment itemfragment;
    private Bitmap qrCodeBitmap;
    private GeneralFunctions generalFunc;
    private List<HashMap<String, String>> allItems;
    private DatabaseReference mDatabase;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        FirebaseApp.initializeApp(this);
        setContentView(R.layout.activity_qr_menu);
        initializeUI();

        mDatabase = FirebaseDatabase.getInstance("https://ersinfo-367917-default-rtdb.firebaseio.com/").getReference();

        addAllItemsButton.setOnClickListener(v -> handleAddAllItems());
        saveQrCodeButton.setOnClickListener(v -> handleSaveQrCode());

        // Make sure this line correctly initializes itemfragment
        itemfragment = (Itemfragment) getSupportFragmentManager().findFragmentById(R.id.item_fragment);
    }


    private void saveImageToGallery(Bitmap bitmap, String fileName) {
        try {
            ContentValues values = new ContentValues();
            values.put(MediaStore.Images.Media.TITLE, fileName);
            values.put(MediaStore.Images.Media.MIME_TYPE, "image/jpeg");

            Uri uri = getContentResolver().insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, values);

            if (uri != null) {
                try (OutputStream outStream = getContentResolver().openOutputStream(uri)) {
                    if (outStream != null) {
                        bitmap.compress(Bitmap.CompressFormat.JPEG, 100, outStream);
                        Toast.makeText(this, "Image saved successfully", Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(this, "Error in saving image", Toast.LENGTH_SHORT).show();
                    }
                }
            } else {
                Toast.makeText(this, "Error in creating media file", Toast.LENGTH_SHORT).show();
            }
        } catch (Exception e) {
            e.printStackTrace();
            Toast.makeText(this, "Error in saving image", Toast.LENGTH_SHORT).show();
        }
    }

    private void initializeUI() {
        // Initialize UI components
        tableNumberInput = findViewById(R.id.table_number_input);
        saveQrCodeButton = findViewById(R.id.save_qr_code_button);
        qrCodeImageView = findViewById(R.id.qr_code_image_view);
        addAllItemsButton = findViewById(R.id.add_all_items_button);
        generalFunc = new GeneralFunctions(this);
        // Initialize other components...
    }

    private void handleAddAllItems() {
        String tableName = tableNumberInput.getText().toString();
        String iCompanyId = generalFunc.getMemberId();

        if (tableName.isEmpty()) {
            Toast.makeText(this, "Please enter a table number.", Toast.LENGTH_SHORT).show();
            return;
        }

        if (itemfragment == null || itemfragment.getAllItems().isEmpty()) {
            Toast.makeText(this, "Items could not be loaded. Please try again.", Toast.LENGTH_SHORT).show();
            return;
        }

        ArrayList<HashMap<String, String>> allItems = itemfragment.getAllItems();
        String itemIds = TextUtils.join(",", getItemIdList(allItems));
        addTableWithItems(tableName, iCompanyId, itemIds);
    }

    private void addTableWithItems(String tableName, String iCompanyId, String itemIds) {
        String uniqueId = mDatabase.child("tables").push().getKey();
        if (uniqueId == null) {
            Toast.makeText(this, "Error generating unique ID for table.", Toast.LENGTH_SHORT).show();
            return;
        }

        TableData tableData = new TableData(iCompanyId, tableName, itemIds);
        mDatabase.child("tables").child(uniqueId).setValue(tableData)
                .addOnSuccessListener(aVoid -> {
                    Toast.makeText(this, "Table added successfully", Toast.LENGTH_SHORT).show();
                    generateAndSetQRCode(uniqueId);
                })
                .addOnFailureListener(e -> Toast.makeText(this, "Failed to add table", Toast.LENGTH_SHORT).show());
    }

    private void generateAndSetQRCode(String uniqueId) {
        try {
            qrCodeBitmap = generateQRCodeBitmap(uniqueId);
            qrCodeImageView.setImageBitmap(qrCodeBitmap);
        } catch (WriterException e) {
            e.printStackTrace();
            Toast.makeText(this, "Failed to generate QR Code: " + e.getMessage(), Toast.LENGTH_LONG).show();
        }
    }


    private void sendItemsToFirebase(String uniqueId, String iCompanyId, String TableName, String itemIds) {
        TableData tableData = new TableData(iCompanyId, TableName, itemIds);
        mDatabase.child("tables").child(uniqueId).setValue(tableData)
                .addOnSuccessListener(aVoid -> Toast.makeText(QRMenuActivity.this, "Table added successfully", Toast.LENGTH_SHORT).show())
                .addOnFailureListener(e -> Toast.makeText(QRMenuActivity.this, "Failed to add table", Toast.LENGTH_SHORT).show());
    }

    private Bitmap generateQRCodeBitmap(String uniqueId) throws WriterException {
        Hashtable<EncodeHintType, ErrorCorrectionLevel> hintMap = new Hashtable<>();
        hintMap.put(EncodeHintType.ERROR_CORRECTION, ErrorCorrectionLevel.H);
        QRCodeWriter qrCodeWriter = new QRCodeWriter();

        BitMatrix bitMatrix = qrCodeWriter.encode(uniqueId, BarcodeFormat.QR_CODE, 200, 200, hintMap);
        int width = bitMatrix.getWidth();
        int height = bitMatrix.getHeight();

        Bitmap qrBitmap = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
        for (int x = 0; x < width; x++) {
            for (int y = 0; y < height; y++) {
                qrBitmap.setPixel(x, y, bitMatrix.get(x, y) ? Color.BLACK : Color.WHITE);
            }
        }
        return getRoundedCornerBitmap(qrBitmap, 20);
    }

    private List<HashMap<String, String>> getItemIds(List<HashMap<String, String>> items) {
        List<HashMap<String, String>> itemData = new ArrayList<>();
        for (HashMap<String, String> item : items) {
            HashMap<String, String> itemInfo = new HashMap<>();
            itemInfo.put("iMenuItemId", item.get("iMenuItemId"));
            itemInfo.put("iMenuCategoryId", item.get("iMenuCategoryId"));
            itemData.add(itemInfo);
        }
        return itemData;
    }

    private List<String> getItemIdList(List<HashMap<String, String>> items) {
        List<String> itemIdList = new ArrayList<>();
        for (HashMap<String, String> item : items) {
            itemIdList.add(item.get("iMenuItemId"));
        }
        return itemIdList;
    }

    private void handleSaveQrCode() {
        if (qrCodeBitmap != null) {
            saveImageToGallery(qrCodeBitmap, "QRCode_" + tableNumberInput.getText().toString());
        } else {
            Toast.makeText(this, "No QR Code generated yet.", Toast.LENGTH_SHORT).show();
        }
    }

    public static Bitmap getRoundedCornerBitmap(Bitmap bitmap, int pixels) {
        Bitmap output = Bitmap.createBitmap(bitmap.getWidth(), bitmap.getHeight(), Bitmap.Config.ARGB_8888);
        Canvas canvas = new Canvas(output);

        final Paint paint = new Paint();
        final Rect rect = new Rect(0, 0, bitmap.getWidth(), bitmap.getHeight());
        final RectF rectF = new RectF(rect);
        final float roundPx = pixels;

        paint.setAntiAlias(true);
        canvas.drawARGB(0, 0, 0, 0);
        canvas.drawRoundRect(rectF, roundPx, roundPx, paint);

        paint.setXfermode(new PorterDuffXfermode(PorterDuff.Mode.SRC_IN));
        canvas.drawBitmap(bitmap, rect, rect, paint);

        return output;
    }

}

class TableData {
    public String iCompanyId;
    public String TableName;
    public String itemIds;  // Storing item IDs as a comma-separated string

    public TableData(String iCompanyId, String TableName, String itemIds) {
        this.iCompanyId = iCompanyId;
        this.TableName = TableName;
        this.itemIds = itemIds;
    }
}*/

// my previous codes

public class QRMenuActivity extends AppCompatActivity {
    private EditText tableNumberInput;
    private Button saveQrCodeButton;
    private Button addAllItemsButton;
    private ImageView qrCodeImageView;
    private Itemfragment itemfragment;
    private Bitmap qrCodeBitmap;
    private GeneralFunctions generalFunc;
    private List<HashMap<String, String>> allItems;
    private DatabaseReference firebaseDatabaseUrl;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        FirebaseApp.initializeApp(this);
        try {
            setContentView(R.layout.activity_qr_menu);
            tableNumberInput = findViewById(R.id.table_number_input);
            saveQrCodeButton = findViewById(R.id.save_qr_code_button);
            qrCodeImageView = findViewById(R.id.qr_code_image_view);
            addAllItemsButton = findViewById(R.id.add_all_items_button);
            generalFunc = new GeneralFunctions(this);

            addAllItemsButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    String TableName = tableNumberInput.getText().toString();

                    if (!TableName.isEmpty()) {
                        Itemfragment itemFragment = (Itemfragment) getSupportFragmentManager().findFragmentById(R.id.item_fragment);

                        if (itemFragment != null) {
                            ArrayList<HashMap<String, String>> allItems = itemFragment.getAllItems();
                            String iCompanyId = generalFunc.getMemberId();

                            String firebaseDatabaseUrl = "https://ersinfo-367917-default-rtdb.firebaseio.com/";

                            // Reference to Firebase Realtime Database
                            DatabaseReference databaseRef = FirebaseDatabase.getInstance(firebaseDatabaseUrl).getReference("tables");

                            // Generating a unique key for the table
                            String tableKey = databaseRef.push().getKey();

                            if (tableKey != null) {
                                // Preparing data to save in Firebase
                                Map<String, Object> tableData = new HashMap<>();
                                tableData.put("TableName", TableName);
                                tableData.put("iCompanyId", iCompanyId);
                                tableData.put("itemsIds", getItemIdList(allItems));

                                // Saving data to Firebase
                                databaseRef.child(tableKey).setValue(tableData)
                                        .addOnSuccessListener(new OnSuccessListener<Void>() {
                                            @Override
                                            public void onSuccess(Void aVoid) {
                                                // Generating QR Code
                                                try {
                                                    qrCodeBitmap = generateQRCodeBitmap(tableKey);
                                                    qrCodeImageView.setImageBitmap(qrCodeBitmap);
                                                    Toast.makeText(QRMenuActivity.this, "Table data saved and QR Code generated", Toast.LENGTH_SHORT).show();
                                                } catch (WriterException e) {
                                                    e.printStackTrace();
                                                    Toast.makeText(QRMenuActivity.this, "Error generating QR Code", Toast.LENGTH_SHORT).show();
                                                }
                                            }
                                        })
                                        .addOnFailureListener(new OnFailureListener() {
                                            @Override
                                            public void onFailure(@NonNull Exception e) {
                                                Toast.makeText(QRMenuActivity.this, "Failed to save table data", Toast.LENGTH_SHORT).show();
                                            }
                                        });
                            } else {
                                Toast.makeText(QRMenuActivity.this, "Error generating table key", Toast.LENGTH_SHORT).show();
                            }
                        } else {
                            Toast.makeText(QRMenuActivity.this, "Items could not be loaded. Please try again.", Toast.LENGTH_SHORT).show();
                        }
                    } else {
                        Toast.makeText(QRMenuActivity.this, "Please enter a table number.", Toast.LENGTH_SHORT).show();
                    }
                }
            });

            saveQrCodeButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (qrCodeBitmap != null) {
                        saveImageToGallery(qrCodeBitmap, "QRCode_" + tableNumberInput.getText().toString());
                    } else {
                        Toast.makeText(QRMenuActivity.this, "No QR Code generated yet.", Toast.LENGTH_SHORT).show();
                    }
                }
            });

            FragmentManager fragmentManager = getSupportFragmentManager();
            itemfragment = (Itemfragment) fragmentManager.findFragmentById(R.id.item_fragment);
            allItems = itemfragment.getAllItems();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private Bitmap generateQRCodeBitmap(String tableNumber) throws WriterException {
        try {
            Hashtable<EncodeHintType, ErrorCorrectionLevel> hintMap = new Hashtable<>();
            hintMap.put(EncodeHintType.ERROR_CORRECTION, ErrorCorrectionLevel.H);
            QRCodeWriter qrCodeWriter = new QRCodeWriter();

            BitMatrix bitMatrix = qrCodeWriter.encode(tableNumber, BarcodeFormat.QR_CODE, 200, 200, hintMap);
            int width = bitMatrix.getWidth();
            int height = bitMatrix.getHeight();

            Bitmap qrBitmap = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);

            for (int x = 0; x < width; x++) {
                for (int y = 0; y < height; y++) {
                    qrBitmap.setPixel(x, y, bitMatrix.get(x, y) ? Color.BLACK : Color.WHITE);
                }
            }

            return getRoundedCornerBitmap(qrBitmap, 20); // Adjust the rounded corner value as needed

        } catch (Exception e) {
            e.printStackTrace();
            Log.e("QRMenuActivity", "Error generating QR Code: ", e);
            throw e;
        }
    }

    private List<HashMap<String, String>> getItemIds(List<HashMap<String, String>> items) {
        List<HashMap<String, String>> itemData = new ArrayList<>();
        for (HashMap<String, String> item : items) {
            HashMap<String, String> itemInfo = new HashMap<>();
            itemInfo.put("iMenuItemId", item.get("iMenuItemId"));
            itemInfo.put("iMenuCategoryId", item.get("iMenuCategoryId"));
            itemData.add(itemInfo);
        }
        return itemData;
    }

    private List<String> getItemIdList(List<HashMap<String, String>> items) {
        List<String> itemIdList = new ArrayList<>();
        for (HashMap<String, String> item : items) {
            itemIdList.add(item.get("iMenuItemId"));
        }
        return itemIdList;
    }

    public void saveImageToGallery(Bitmap bitmap, String fileName) {
        try {
            ContentValues values = new ContentValues();
            values.put(MediaStore.Images.Media.TITLE, fileName);
            values.put(MediaStore.Images.Media.MIME_TYPE, "image/jpeg");

            Uri uri = getContentResolver().insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, values);

            if (uri != null) {
                try (OutputStream outStream = getContentResolver().openOutputStream(uri)) {
                    if (outStream != null) {
                        bitmap.compress(Bitmap.CompressFormat.JPEG, 100, outStream);
                        Toast.makeText(this, "Image saved successfully", Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(this, "Error in saving image", Toast.LENGTH_SHORT).show();
                    }
                }
            } else {
                Toast.makeText(this, "Error in creating media file", Toast.LENGTH_SHORT).show();
            }
        } catch (Exception e) {
            e.printStackTrace();
            Toast.makeText(this, "Error in saving image", Toast.LENGTH_SHORT).show();
        }
    }


    public static Bitmap getRoundedCornerBitmap(Bitmap bitmap, int pixels) {
        Bitmap output = Bitmap.createBitmap(bitmap.getWidth(), bitmap.getHeight(), Bitmap.Config.ARGB_8888);
        Canvas canvas = new Canvas(output);

        final Paint paint = new Paint();
        final Rect rect = new Rect(0, 0, bitmap.getWidth(), bitmap.getHeight());
        final RectF rectF = new RectF(rect);
        final float roundPx = pixels;

        paint.setAntiAlias(true);
        canvas.drawARGB(0, 0, 0, 0);
        canvas.drawRoundRect(rectF, roundPx, roundPx, paint);

        paint.setXfermode(new PorterDuffXfermode(PorterDuff.Mode.SRC_IN));
        canvas.drawBitmap(bitmap, rect, rect, paint);

        return output;
    }
}

// uncomment dated 06/12/2023  12:50 AM
            /*addAllItemsButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    String TableName = tableNumberInput.getText().toString();

                    if (!TableName.isEmpty()) {
                        Itemfragment itemFragment = (Itemfragment) getSupportFragmentManager().findFragmentById(R.id.item_fragment);

                        if (itemFragment != null) {
                            ArrayList<HashMap<String, String>> allItems = itemFragment.getAllItems();
                            String itemIds = TextUtils.join(",", getItemIds(allItems));
                            String iCompanyId = generalFunc.getMemberId();

                            JSONObject qrContent = new JSONObject();
                            try {
                                qrContent.put("TableName", TableName);
                                qrContent.put("iCompanyId", iCompanyId);
                                qrContent.put("items", new JSONArray(getItemIdList(allItems)));

                                qrCodeBitmap = generateQRCodeBitmap(qrContent.toString());
                                qrCodeImageView.setImageBitmap(qrCodeBitmap);
                            } catch (JSONException | WriterException e) {
                                e.printStackTrace();
                            }

                            RequestQueue queue = Volley.newRequestQueue(QRMenuActivity.this);
                            String url = "https://ersinfo.in/add_table.php";

                            StringRequest stringRequest = new StringRequest(Request.Method.POST, url,
                                    new Response.Listener<String>() {
                                        @Override
                                        public void onResponse(String response) {
                                            JSONObject jsonResponse;
                                            try {
                                                jsonResponse = new JSONObject(response);
                                                String status = jsonResponse.getString("status");
                                                if (status.equals("success")) {
                                                    Toast.makeText(QRMenuActivity.this, "Table added successfully", Toast.LENGTH_SHORT).show();
                                                } else {
                                                    Toast.makeText(QRMenuActivity.this, "Failed to add table. Please try again.", Toast.LENGTH_SHORT).show();
                                                }
                                            } catch (JSONException e) {
                                                e.printStackTrace();
                                                Toast.makeText(QRMenuActivity.this, "Failed to add table", Toast.LENGTH_SHORT).show();
                                            }
                                            Log.d("Response", response);
                                        }
                                    }, new Response.ErrorListener() {

                                @Override
                                public void onErrorResponse(VolleyError error) {
                                    Log.e("AddTableError", "Error: " + error.toString());
                                    if (error.networkResponse != null) {
                                        Log.e("Status code", String.valueOf(error.networkResponse.statusCode));
                                        Log.e("Network Time MS", String.valueOf(error.networkResponse.networkTimeMs));
                                        Log.e("Is Timeout", String.valueOf(error.networkResponse.notModified));
                                    }
                                }
                            }) {
                                @Override
                                protected Map<String, String> getParams() {
                                    Map<String, String> params = new HashMap<>();
                                    params.put("iCompanyId", iCompanyId);
                                    params.put("TableName", TableName);
                                    params.put("iMenuItemId", itemIds);
                                    return params;
                                }
                            };

                            Log.d("Request", "URL: " + url);
                            Log.d("Request", "iCompanyId: " + iCompanyId);
                            Log.d("Request", "TableName: " + TableName);
                            Log.d("Request", "iMenuItemId: " + itemIds);
                            queue.add(stringRequest);
                        } else {
                            Toast.makeText(QRMenuActivity.this, "Items could not be loaded. Please try again.", Toast.LENGTH_SHORT).show();
                        }
                    } else {
                        Toast.makeText(QRMenuActivity.this, "Please enter a table number.", Toast.LENGTH_SHORT).show();
                    }
                }
            });*/


// uncomment, dated 05/12/2023   11:50 pm

    /*private Bitmap generateQRCodeBitmap(String tableNumber) throws WriterException {
        try {
            Hashtable<EncodeHintType, ErrorCorrectionLevel> hintMap = new Hashtable<>();
            hintMap.put(EncodeHintType.ERROR_CORRECTION, ErrorCorrectionLevel.H);
            QRCodeWriter qrCodeWriter = new QRCodeWriter();

            BitMatrix bitMatrix = qrCodeWriter.encode(tableNumber, BarcodeFormat.QR_CODE, 200, 200, hintMap);
            int width = bitMatrix.getWidth();
            int height = bitMatrix.getHeight();

            Bitmap qrBitmap = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);

            for (int x = 0; x < width; x++) {
                for (int y = 0; y < height; y++) {
                    qrBitmap.setPixel(x, y, bitMatrix.get(x, y) ? Color.BLACK : Color.WHITE);
                }
            }

            return getRoundedCornerBitmap(qrBitmap, 20); // Adjust the rounded corner value as needed

        } catch (Exception e) {
            e.printStackTrace();
            Log.e("QRMenuActivity", "Error generating QR Code: ", e);
            throw e;
        }
    }*/


/*

public class QRMenuActivity extends AppCompatActivity {
    private EditText tableNumberInput;
    private Button saveQrCodeButton;
    private Button addAllItemsButton;
    private ImageView qrCodeImageView;
    private Itemfragment itemfragment;
    private Bitmap qrCodeBitmap;
    private GeneralFunctions generalFunc;
    private List<HashMap<String, String>> allItems;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        try {
            setContentView(R.layout.activity_qr_menu);
            tableNumberInput = findViewById(R.id.table_number_input);
            saveQrCodeButton = findViewById(R.id.save_qr_code_button);
            qrCodeImageView = findViewById(R.id.qr_code_image_view);
            addAllItemsButton = findViewById(R.id.add_all_items_button);
            generalFunc = new GeneralFunctions(this);

            addAllItemsButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    String TableName = tableNumberInput.getText().toString();

                    if (!TableName.isEmpty()) {
                        Itemfragment itemFragment = (Itemfragment) getSupportFragmentManager().findFragmentById(R.id.item_fragment);

                        if (itemFragment != null) {
                            ArrayList<HashMap<String, String>> allItems = itemFragment.getAllItems();
                            String itemIds = TextUtils.join(",", getItemIds(allItems));
                            String iCompanyId = generalFunc.getMemberId();

                            JSONObject qrContent = new JSONObject();
                            try {
                                qrContent.put("TableName", TableName);
                                qrContent.put("iCompanyId", iCompanyId);
                                qrContent.put("items", new JSONArray(getItemIdList(allItems)));

                                qrCodeBitmap = generateQRCodeBitmap(qrContent.toString());
                                qrCodeImageView.setImageBitmap(qrCodeBitmap);
                            } catch (JSONException | WriterException e) {
                                e.printStackTrace();
                            }

                            RequestQueue queue = Volley.newRequestQueue(QRMenuActivity.this);
                            String url = "https://ersinfo.in/add_table.php";

                            StringRequest stringRequest = new StringRequest(Request.Method.POST, url,
                                    new Response.Listener<String>() {
                                        @Override
                                        public void onResponse(String response) {
                                            JSONObject jsonResponse;
                                            try {
                                                jsonResponse = new JSONObject(response);
                                                String status = jsonResponse.getString("status");
                                                if (status.equals("success")) {
                                                    Toast.makeText(QRMenuActivity.this, "Table added successfully", Toast.LENGTH_SHORT).show();
                                                } else {
                                                    Toast.makeText(QRMenuActivity.this, "Failed to add table. Please try again.", Toast.LENGTH_SHORT).show();
                                                }
                                            } catch (JSONException e) {
                                                e.printStackTrace();
                                                Toast.makeText(QRMenuActivity.this, "Failed to add table", Toast.LENGTH_SHORT).show();
                                            }
                                            Log.d("Response", response);
                                        }
                                    }, new Response.ErrorListener() {

                                @Override
                                public void onErrorResponse(VolleyError error) {
                                    Log.e("AddTableError", "Error: " + error.toString());
                                    if (error.networkResponse != null) {
                                        Log.e("Status code", String.valueOf(error.networkResponse.statusCode));
                                        Log.e("Network Time MS", String.valueOf(error.networkResponse.networkTimeMs));
                                        Log.e("Is Timeout", String.valueOf(error.networkResponse.notModified));
                                    }
                                }
                            }) {
                                @Override
                                protected Map<String, String> getParams() {
                                    Map<String, String> params = new HashMap<>();
                                    params.put("iCompanyId", iCompanyId);
                                    params.put("TableName", TableName);
                                    params.put("iMenuItemId", itemIds);
                                    return params;
                                }
                            };

                            Log.d("Request", "URL: " + url);
                            Log.d("Request", "iCompanyId: " + iCompanyId);
                            Log.d("Request", "TableName: " + TableName);
                            Log.d("Request", "iMenuItemId: " + itemIds);
                            queue.add(stringRequest);
                        } else {
                            Toast.makeText(QRMenuActivity.this, "Items could not be loaded. Please try again.", Toast.LENGTH_SHORT).show();
                        }
                    } else {
                        Toast.makeText(QRMenuActivity.this, "Please enter a table number.", Toast.LENGTH_SHORT).show();
                    }
                }
            });

            saveQrCodeButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (qrCodeBitmap != null) {
                        saveImageToGallery(qrCodeBitmap, "QRCode_" + tableNumberInput.getText().toString());
                    } else {
                        Toast.makeText(QRMenuActivity.this, "No QR Code generated yet.", Toast.LENGTH_SHORT).show();
                    }
                }
            });

            FragmentManager fragmentManager = getSupportFragmentManager();
            itemfragment = (Itemfragment) fragmentManager.findFragmentById(R.id.item_fragment);
            allItems = itemfragment.getAllItems();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private Bitmap generateQRCodeBitmap(String tableNumber) throws WriterException {
        try {
            Hashtable<EncodeHintType, ErrorCorrectionLevel> hintMap = new Hashtable<>();
            hintMap.put(EncodeHintType.ERROR_CORRECTION, ErrorCorrectionLevel.H);
            QRCodeWriter qrCodeWriter = new QRCodeWriter();

            BitMatrix bitMatrix = qrCodeWriter.encode(tableNumber, BarcodeFormat.QR_CODE, 200, 200, hintMap);
            int width = bitMatrix.getWidth();
            int height = bitMatrix.getHeight();

            Bitmap qrBitmap = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);

            for (int x = 0; x < width; x++) {
                for (int y = 0; y < height; y++) {
                    qrBitmap.setPixel(x, y, bitMatrix.get(x, y) ? Color.BLACK : Color.WHITE);
                }
            }

            return getRoundedCornerBitmap(qrBitmap, 20); // Adjust the rounded corner value as needed

        } catch (Exception e) {
            e.printStackTrace();
            Log.e("QRMenuActivity", "Error generating QR Code: ", e);
            throw e;
        }
    }

    private List<HashMap<String, String>> getItemIds(List<HashMap<String, String>> items) {
        List<HashMap<String, String>> itemData = new ArrayList<>();
        for (HashMap<String, String> item : items) {
            HashMap<String, String> itemInfo = new HashMap<>();
            itemInfo.put("iMenuItemId", item.get("iMenuItemId"));
            itemInfo.put("iMenuCategoryId", item.get("iMenuCategoryId"));
            itemData.add(itemInfo);
        }
        return itemData;
    }

    private List<String> getItemIdList(List<HashMap<String, String>> items) {
        List<String> itemIdList = new ArrayList<>();
        for (HashMap<String, String> item : items) {
            itemIdList.add(item.get("iMenuItemId"));
        }
        return itemIdList;
    }

    public void saveImageToGallery(Bitmap bitmap, String fileName) {
        try {
            ContentValues values = new ContentValues();
            values.put(MediaStore.Images.Media.TITLE, fileName);
            values.put(MediaStore.Images.Media.MIME_TYPE, "image/jpeg");

            Uri uri = getContentResolver().insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, values);

            if (uri != null) {
                try (OutputStream outStream = getContentResolver().openOutputStream(uri)) {
                    if (outStream != null) {
                        bitmap.compress(Bitmap.CompressFormat.JPEG, 100, outStream);
                        Toast.makeText(this, "Image saved successfully", Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(this, "Error in saving image", Toast.LENGTH_SHORT).show();
                    }
                }
            } else {
                Toast.makeText(this, "Error in creating media file", Toast.LENGTH_SHORT).show();
            }
        } catch (Exception e) {
            e.printStackTrace();
            Toast.makeText(this, "Error in saving image", Toast.LENGTH_SHORT).show();
        }
    }


    public static Bitmap getRoundedCornerBitmap(Bitmap bitmap, int pixels) {
        Bitmap output = Bitmap.createBitmap(bitmap.getWidth(), bitmap.getHeight(), Bitmap.Config.ARGB_8888);
        Canvas canvas = new Canvas(output);

        final Paint paint = new Paint();
        final Rect rect = new Rect(0, 0, bitmap.getWidth(), bitmap.getHeight());
        final RectF rectF = new RectF(rect);
        final float roundPx = pixels;

        paint.setAntiAlias(true);
        canvas.drawARGB(0, 0, 0, 0);
        canvas.drawRoundRect(rectF, roundPx, roundPx, paint);

        paint.setXfermode(new PorterDuffXfermode(PorterDuff.Mode.SRC_IN));
        canvas.drawBitmap(bitmap, rect, rect, paint);

        return output;
    }

*/
