package com.okbuddy.store;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import com.datepicker.files.SlideDateTimeListener;
import com.datepicker.files.SlideDateTimePicker;
import com.general.files.GeneralFunctions;
import com.general.files.ImageFilePath;
import com.general.files.MyApp;
import com.general.files.OpenProgressUpdateDialog;
import com.general.files.OpenSourceSelectionDialog;
import com.general.files.StartActProcess;
import com.general.files.UploadProfileImage;
import com.utils.Logger;
import com.utils.Utils;
import com.view.CreateRoundedView;
import com.view.GenerateAlertBox;
import com.view.MButton;
import com.view.MTextView;
import com.view.MaterialRippleLayout;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;

public class UploadDocActivity extends AppCompatActivity {

    public static final int MEDIA_TYPE_IMAGE = 1;
    private static final String IMAGE_DIRECTORY_NAME = "Temp";
    final int PICK_FILE_REQUEST_CODE = 159;
    public boolean isuploadimageNew = true;
    MTextView titleTxt;
    ImageView backImgView;
    GeneralFunctions generalFunc;
    MButton btn_type2;
    MTextView helpInfoTxtView;
    ImageView dummyInfoCardImgView;
    private Uri fileUri;
    private static final int MANAGE_APP_ALL_FILES_ACCESS_REQUEST_CODE = 2296;
    MTextView expBox;
    MTextView expBoxLBL;
    MTextView expBoxTXT;
    FrameLayout expDateSelectArea;

    String selectedDocumentPath = "";

    ImageView imgeselectview;

    boolean isbtnclick = false;
    String pathForCameraImage = "";
    String[] tsite_upload_docs_file_extensions_arr = null;
    private JSONObject obj_userProfile;

    boolean isDatePickerOpen = false;

    RelativeLayout selectyear_layout;
    UploadProfileImage uploadProfileImage;
    LinearLayout editArea;
    MTextView editTxtView, viewTxtView;
    String vimage = "";
    View editView;

    @Override
    public void finishActivity(int requestCode) {
        super.finishActivity(requestCode);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_upload_doc);

        Toolbar mToolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(mToolbar);

        generalFunc = MyApp.getInstance().getGeneralFun(getActContext());
        if (!getIntent().getStringExtra("vimage").equalsIgnoreCase("")) {
            vimage = getIntent().getStringExtra("vimage");
            Logger.d("ImagePath", "::" + vimage);
        }

        titleTxt = (MTextView) findViewById(R.id.titleTxt);
        backImgView = (ImageView) findViewById(R.id.backImgView);
        dummyInfoCardImgView = (ImageView) findViewById(R.id.dummyInfoCardImgView);
        helpInfoTxtView = (MTextView) findViewById(R.id.helpInfoTxtView);
        expBox = (MTextView) findViewById(R.id.expBox);
        expBoxLBL = (MTextView) findViewById(R.id.expBoxLBL);
        expBoxTXT = (MTextView) findViewById(R.id.expBoxTxt);
        imgeselectview = (ImageView) findViewById(R.id.imgeselectview);
        expDateSelectArea = (FrameLayout) findViewById(R.id.expDateSelectArea);
        selectyear_layout = (RelativeLayout) findViewById(R.id.selectyear_layout);
        editArea = (LinearLayout) findViewById(R.id.editArea);
        editTxtView = (MTextView) findViewById(R.id.editTxtView);
        editView = findViewById(R.id.editView);
        viewTxtView = (MTextView) findViewById(R.id.viewTxtView);
        editTxtView.setOnClickListener(new setOnClickList());
        viewTxtView.setOnClickListener(new setOnClickList());

        btn_type2 = ((MaterialRippleLayout) findViewById(R.id.btn_type2)).getChildView();
        backImgView.setOnClickListener(new setOnClickList());

        btn_type2.setId(Utils.generateViewId());
        btn_type2.setOnClickListener(new setOnClickList());
        helpInfoTxtView.setOnClickListener(new setOnClickList());
        dummyInfoCardImgView.setOnClickListener(new setOnClickList());


        String userProfileJson = generalFunc.retrieveValue(Utils.USER_PROFILE_JSON);
        obj_userProfile = generalFunc.getJsonObject(userProfileJson);

        tsite_upload_docs_file_extensions_arr = generalFunc.getJsonValueStr("tsite_upload_docs_file_extensions", obj_userProfile).trim().replaceAll(" ", "").split(",");

        new CreateRoundedView(Color.parseColor("#ffffff"), 8, 2, Color.parseColor("#9c9c9c"), selectyear_layout);

        setLabels();


        if (getIntent().getStringExtra("allow_date_change").equalsIgnoreCase("No")) {
            btn_type2.setEnabled(false);
            ((MTextView) findViewById(R.id.noteTxt)).setText(getIntent().getStringExtra("doc_update_disable"));
        }
    }

    public void setLabels() {
        editTxtView.setText(generalFunc.retrieveLangLBl("", "LBL_EDIT"));
        viewTxtView.setText(generalFunc.retrieveLangLBl("", "LBL_VIEW"));
        titleTxt.setText(generalFunc.retrieveLangLBl("", "LBL_UPLOAD_DOC"));
        btn_type2.setText(generalFunc.retrieveLangLBl("", "LBL_BTN_SUBMIT_TXT"));
        helpInfoTxtView.setText(generalFunc.retrieveLangLBl("", "LBL_SELECT_DOC"));
        expBox.setText(generalFunc.retrieveLangLBl("", "LBL_SELECT_TXT"));
        expBoxLBL.setText(generalFunc.retrieveLangLBl("", "LBL_EXPIRY_DATE"));
        // expBoxLBL.setBothText("Select");

        if (getIntent().getStringExtra("ex_status").equals("yes")) {
            expBoxTXT.setText(getIntent().getStringExtra("ex_date"));
            // expBox.setBothText("Select");
            expDateSelectArea.setVisibility(View.VISIBLE);
        } else {
            expDateSelectArea.setVisibility(View.GONE);
        }

        String doc_file = getIntent().getStringExtra("doc_file");
        if (!doc_file.equals("")) {
            selectedDocumentPath = doc_file;
            imgeselectview.setVisibility(View.VISIBLE);
            helpInfoTxtView.setVisibility(View.GONE);
            editArea.setVisibility(View.VISIBLE);
            // dummyInfoCardImgView.setAlpha(0.2f);
            dummyInfoCardImgView.setAlpha(0.2f);
            dummyInfoCardImgView.setImageDrawable(getResources().getDrawable(R.drawable.ic_card_documents));
            isuploadimageNew = false;

            if (!vimage.equalsIgnoreCase("")) {
                viewTxtView.setVisibility(View.VISIBLE);
                editView.setVisibility(View.VISIBLE);

            } else {
                viewTxtView.setVisibility(View.GONE);
                editView.setVisibility(View.GONE);
            }
        }


        // Utils.removeInput(expBox);
        selectyear_layout.setOnTouchListener(new setOnTouchList());
        selectyear_layout.setOnClickListener(new setOnClickList());
    }


    public class setOnTouchList implements View.OnTouchListener {

        @Override
        public boolean onTouch(View view, MotionEvent motionEvent) {
            if (motionEvent.getAction() == MotionEvent.ACTION_UP && !view.hasFocus()) {
                view.performClick();
            }
            return true;
        }
    }

    public Context getActContext() {
        return UploadDocActivity.this;
    }


    @Override
    public void onSaveInstanceState(Bundle savedInstanceState) {
        // Save the user's current state
        super.onSaveInstanceState(savedInstanceState);
        savedInstanceState.putParcelable("file_uri", fileUri);
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);

        // get the file url
        fileUri = savedInstanceState.getParcelable("file_uri");
    }

    public void checkData() {

        if (expDateSelectArea.getVisibility() == View.VISIBLE && !Utils.checkText(expBoxTXT.getText().toString())) {
            generalFunc.showMessage(generalFunc.getCurrentView((Activity) getActContext()), generalFunc.retrieveLangLBl("Expiry date is required.", "LBL_EXP_DATE_REQUIRED"));
            return;
        }

        if (selectedDocumentPath.equals("")) {
            generalFunc.showMessage(generalFunc.getCurrentView((Activity) getActContext()), generalFunc.retrieveLangLBl("Please attach your document.", "LBL_SELECT_DOC_ERROR"));
            return;
        }

        if (isbtnclick) {
            return;
        }
        isbtnclick = true;
        Handler handler = new Handler();
        handler.postDelayed(new Runnable() {
            @Override
            public void run() {
                isbtnclick = false;
            }
        }, 1000);

        ArrayList<String[]> paramsList = new ArrayList<>();
        paramsList.add(Utils.generateImageParams("type", "uploadcompanydocument"));
        paramsList.add(Utils.generateImageParams("iMemberId", generalFunc.getMemberId()));
        paramsList.add(Utils.generateImageParams("MemberType", Utils.app_type));
        paramsList.add(Utils.generateImageParams("doc_usertype", getIntent().getStringExtra("PAGE_TYPE")));
        paramsList.add(Utils.generateImageParams("doc_masterid", getIntent().getStringExtra("doc_masterid")));
        paramsList.add(Utils.generateImageParams("doc_name", getIntent().getStringExtra("doc_name")));
        paramsList.add(Utils.generateImageParams("doc_id", getIntent().getStringExtra("doc_id")));
        paramsList.add(Utils.generateImageParams("tSessionId", generalFunc.getMemberId().equals("") ? "" : generalFunc.retrieveValue(Utils.SESSION_ID_KEY)));
        paramsList.add(Utils.generateImageParams("GeneralUserType", Utils.app_type));
        paramsList.add(Utils.generateImageParams("GeneralMemberId", generalFunc.getMemberId()));
        paramsList.add(Utils.generateImageParams("iServiceId", generalFunc.getServiceId()));
        paramsList.add(Utils.generateImageParams("ex_date", getIntent().getStringExtra("ex_status").equals("yes") ? Utils.getText(expBoxTXT) : ""));
        paramsList.add(Utils.generateImageParams("iServiceId", generalFunc.getServiceId()));
        if (!getIntent().getStringExtra("iDriverVehicleId").equals("")) {
            paramsList.add(Utils.generateImageParams("iDriverVehicleId", getIntent().getStringExtra("iDriverVehicleId")));
            // new UploadProfileImage(UploadDocActivity.this, "", Utils.TempProfileImageName, paramsList, "FILE").execute();
        }

        if (!getIntent().getStringExtra("doc_file").equals("")) {

            if (isuploadimageNew) {
                uploadProfileImage = new UploadProfileImage(UploadDocActivity.this, selectedDocumentPath, "TempFile." + Utils.getFileExt(selectedDocumentPath), paramsList, "FILE");
                uploadProfileImage.execute(true);
            } else {
                paramsList.add(Utils.generateImageParams("doc_file", selectedDocumentPath));
                uploadProfileImage = new UploadProfileImage(UploadDocActivity.this, "", "TempFile." + Utils.getFileExt(selectedDocumentPath), paramsList, "FILE");
                uploadProfileImage.execute(false);
            }
        } else {


            for (int i = 0; i < paramsList.size(); i++) {
                String[] arrData = paramsList.get(i);


                Logger.d("Parametres", "::" + arrData[0] + "," + arrData[1]);
            }
            uploadProfileImage = new UploadProfileImage(UploadDocActivity.this, selectedDocumentPath, "TempFile." + Utils.getFileExt(selectedDocumentPath), paramsList, "FILE");
            uploadProfileImage.execute(true);

        }

    }

//    @Override
//    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
//        super.onActivityResult(requestCode, resultCode, data);
//
//        if (requestCode == PICK_FILE_REQUEST_CODE && resultCode == RESULT_OK/* && data != null*/) {
//
//            File file = new File(new ImageFilePath().getPath(getActContext(), fileUri));
//
//            String filePath = "";
//
//
//            if (file.exists()) {
//                String selPath = new ImageFilePath().getPath(getActContext(), fileUri);
//                filePath = selPath;
//            } else if (data != null) {
//                Uri selectedImageUri = data.getData();
//                String selectedImagePath = new ImageFilePath().getPath(getActContext(), selectedImageUri);
//
//                filePath = selectedImagePath;
//            }
//
//            if (filePath != null) {
//                if (Utils.getFileExt(filePath).equalsIgnoreCase("jpg") || Utils.getFileExt(filePath).equalsIgnoreCase("gif") || Utils.getFileExt(filePath).equalsIgnoreCase("png")
//                        || Utils.getFileExt(filePath).equalsIgnoreCase("jpeg") || Utils.getFileExt(filePath).equalsIgnoreCase("bmp") || Utils.getFileExt(filePath).equalsIgnoreCase("pdf")
//                        || Utils.getFileExt(filePath).equalsIgnoreCase("doc") || Utils.getFileExt(filePath).equalsIgnoreCase("docx") || Utils.getFileExt(filePath).equalsIgnoreCase("txt")) {
//
//                    selectedDocumentPath = filePath;
//                    imgeselectview.setVisibility(View.VISIBLE);
//                    //dummyInfoCardImgView.setAlpha(0.2f);
//                    dummyInfoCardImgView.setImageDrawable(getResources().getDrawable(R.drawable.default_doc_bg_sel));
//                    isuploadimageNew = true;
//
//                } else {
//                    imgeselectview.setVisibility(View.GONE);
//                    generalFunc.showGeneralMessage("", generalFunc.retrieveLangLBl("You have selected wrong file format for document. " +
//                            "Valid formats are pdf, doc, docx, jpg, jpeg, gif, png, bmp, xls, xlxs, txt.", "LBL_WRONG_FILE_SELECTED_TXT"));
//                }
//            } else {
//                generalFunc.showMessage(backImgView, generalFunc.retrieveLangLBl("", "LBL_TRY_AGAIN_TXT"));
//            }
//        }
//    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        String selPath = "";

        // TODO: 28-04-2021 / Viral | Android 11 (30) Store permission code remove | revert 29
        /*if (requestCode == MANAGE_APP_ALL_FILES_ACCESS_REQUEST_CODE) {
            if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
                if (generalFunc.isCameraPermissionGranted()) {
                    if (Environment.isExternalStorageManager()) {
                        openDocChoose();
                    } else {
                        generalFunc.showMessage(generalFunc.getCurrentView((Activity) getActContext()), "Allow this app to use storage access.");
                    }
                } else {
                    generalFunc.showMessage(generalFunc.getCurrentView((Activity) getActContext()), "Allow this app to use camera.");
                }
            }
        } else */if (requestCode == OpenSourceSelectionDialog.CAMERA_CAPTURE_IMAGE_REQUEST_CODE && resultCode == RESULT_OK) {
            vimage = "";
            if (pathForCameraImage.equalsIgnoreCase("")) {
                selPath = new ImageFilePath().getPath(getActContext(), fileUri);
            } else {
                selPath = pathForCameraImage;
            }
            /*boolean isStoragePermissionAvail = false;
            if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
                isStoragePermissionAvail = Environment.isExternalStorageManager();
            } else {
                isStoragePermissionAvail = generalFunc.isStoragePermissionGranted();
            }*/
            // TODO: 28-04-2021 / Viral | Android 11 (30) Store permission code remove | revert 29
            boolean isStoragePermissionAvail = generalFunc.isStoragePermissionGranted();
            if (Utils.isValidImageResolution(selPath) && isStoragePermissionAvail) {
                this.selectedDocumentPath = selPath;
            } else {
                generalFunc.showGeneralMessage("", "Please select image which has minimum is 256 * 256 resolution.");
            }
        } else if ((requestCode == OpenSourceSelectionDialog.SELECT_FILE_BROWSABLE || requestCode == OpenSourceSelectionDialog.SELECT_PICTURE) && resultCode == RESULT_OK) {
            if (data != null) {
                vimage = "";

                try {
                    Uri selectedImageUri = data.getData();
                    String selectedImagePath = new ImageFilePath().getPath(getActContext(), selectedImageUri);

                    if (selectedImagePath == null) {
                        if (ImageFilePath.isGooglePhotosUri(selectedImageUri) || ImageFilePath.isGoogleDriveUri(selectedImageUri)) {
                            generalFunc.showMessage(generalFunc.getCurrentView((Activity) getActContext()), generalFunc.retrieveLangLBl("", "LBL_FILE_CHOOSE_ERROR"));
                            return;
                        }
                        generalFunc.showMessage(generalFunc.getCurrentView((Activity) getActContext()), generalFunc.retrieveLangLBl("Can't read selected image. Please try again.", "LBL_IMAGE_READ_FAILED"));
                        return;
                    }
                    selPath = selectedImagePath;
                } catch (Exception e) {

                }
            }
        }

        if (resultCode != RESULT_CANCELED && (requestCode == OpenSourceSelectionDialog.CAMERA_CAPTURE_IMAGE_REQUEST_CODE || requestCode == OpenSourceSelectionDialog.SELECT_FILE_BROWSABLE || requestCode == OpenSourceSelectionDialog.SELECT_PICTURE)) {
            if (selPath != null) {

                Logger.e("filePath", "::" + Utils.getFileExt(selPath));

                String fileExtension = Utils.getFileExt(selPath);

                if (Arrays.asList(tsite_upload_docs_file_extensions_arr).contains(fileExtension)) {
                    selectedDocumentPath = selPath;
                    imgeselectview.setVisibility(View.VISIBLE);
                    dummyInfoCardImgView.setAlpha(0.2f);
                    dummyInfoCardImgView.setImageDrawable(getResources().getDrawable(R.drawable.ic_card_documents));
                    isuploadimageNew = true;

                    helpInfoTxtView.setVisibility(View.GONE);
                    editArea.setVisibility(View.VISIBLE);

                    if (!vimage.equalsIgnoreCase("")) {
                        viewTxtView.setVisibility(View.VISIBLE);
                        editView.setVisibility(View.VISIBLE);

                    } else {
                        viewTxtView.setVisibility(View.GONE);
                        editView.setVisibility(View.GONE);
                    }
                } else {
                    editArea.setVisibility(View.GONE);
                    imgeselectview.setVisibility(View.GONE);
                    helpInfoTxtView.setVisibility(View.VISIBLE);
                    generalFunc.showGeneralMessage("", generalFunc.retrieveLangLBl("You have selected wrong file format for document. " +
                            "Valid formats are pdf, doc, docx, jpg, jpeg, gif, png, bmp, txt.", "LBL_WRONG_FILE_SELECTED_TXT"));
                }

            } else {
                generalFunc.showMessage(generalFunc.getCurrentView((Activity) getActContext()), generalFunc.retrieveLangLBl("", "LBL_TRY_AGAIN_TXT"));
            }
        }
    }

    public void handleImgUploadResponse(String responseString) {

        if (responseString != null && !responseString.equals("")) {

            boolean isDataAvail = GeneralFunctions.checkDataAvail(Utils.action_str, responseString);

            if (isDataAvail == true) {

                String msgTxt = "";
                if (!generalFunc.getJsonValue("doc_under_review", responseString).equalsIgnoreCase("")) {
                    msgTxt = generalFunc.retrieveLangLBl("", generalFunc.getJsonValue("doc_under_review", responseString));
                } else {
                    msgTxt = generalFunc.retrieveLangLBl("Your document is uploaded successfully", "LBL_UPLOAD_DOC_SUCCESS");
                }
                final GenerateAlertBox generateAlert = new GenerateAlertBox(getActContext());
                generateAlert.setCancelable(false);
                generateAlert.setBtnClickList(btn_id -> {
                    if (openprogressDialog != null) {
                        openprogressDialog.dialog_img_update.cancel();
                    }

                    generateAlert.closeAlertBox();
                    setResult(RESULT_OK);
                    backImgView.performClick();
                });
                generateAlert.setContentMessage("", msgTxt);
                generateAlert.setPositiveBtn(generalFunc.retrieveLangLBl("", "LBL_BTN_OK_TXT"));

                generateAlert.showAlertBox();
            } else {
                generalFunc.showGeneralMessage("",
                        generalFunc.retrieveLangLBl("", generalFunc.getJsonValue(Utils.message_str, responseString)));
            }
        } else {
            if (openprogressDialog != null) {
                openprogressDialog.dialog_img_update.cancel();
            }
            generalFunc.showError();
        }

    }

    public void handleCancelupload() {
        if (openprogressDialog != null) {
            openprogressDialog.dialog_img_update.cancel();
        }
        openprogressDialog = null;
    }

    public void openDateSelection() {

        if (isDatePickerOpen) {
            return;
        }
        Logger.d("openDateSelection", "::" + Calendar.getInstance().getTime());
        new SlideDateTimePicker.Builder(getSupportFragmentManager())
                .setListener(new SlideDateTimeListener() {
                    @Override
                    public void onDateTimeSet(Date date) {
                        isDatePickerOpen = false;
                        expBoxTXT.setText(Utils.convertDateToFormat("yyyy-MM-dd", date));
                    }

                    @Override
                    public void onDateTimeCancel() {
                        isDatePickerOpen = false;
                        super.onDateTimeCancel();
                    }
                })
                .setInitialDate(new Date())
                .setMinDate(Calendar.getInstance().getTime())
                //.setMaxDate(maxDate)
                .setIs24HourTime(true)
                .setTimePickerEnabled(false)
                //.setTheme(SlideDateTimePicker.HOLO_DARK)
                .setIndicatorColor(getResources().getColor(R.color.appThemeColor_2))
                .build()
                .show();
        isDatePickerOpen = true;


    }

    private void openDocChoose() {
        OpenSourceSelectionDialog openSourceDialog = new OpenSourceSelectionDialog(getActContext(), generalFunc, true);
        openSourceDialog.setOnFileUriGenerateListener((fileUri, pathForCameraImage) -> {
            this.fileUri = fileUri;
            this.pathForCameraImage = pathForCameraImage;
        });
        openSourceDialog.run();
    }

    public class setOnClickList implements View.OnClickListener {

        @Override
        public void onClick(View view) {
            int i = view.getId();
            Utils.hideKeyboard(UploadDocActivity.this);
            if (i == R.id.backImgView) {
                UploadDocActivity.super.onBackPressed();
            } else if (i == btn_type2.getId()) {
                checkData();
            } else if (i == helpInfoTxtView.getId() || i == dummyInfoCardImgView.getId()) {
                selectImage();
            } else if (i == R.id.selectyear_layout) {
                openDateSelection();
            } else if (i == R.id.editTxtView) {
                selectImage();
            } else if (i == R.id.viewTxtView) {
                new StartActProcess(getActContext()).openURL(vimage);

            }
        }
    }

    private void selectImage() {
        /*if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
            if (Environment.isExternalStorageManager()) {
                if (generalFunc.isCameraPermissionGranted()) {
                    openDocChoose();
                } else {
                    generalFunc.showMessage(generalFunc.getCurrentView((Activity) getActContext()), "Allow this app to use camera.");
                }
            } else {
                try {
                    Intent intent = new Intent(Settings.ACTION_MANAGE_APP_ALL_FILES_ACCESS_PERMISSION);
                    intent.addCategory("android.intent.category.DEFAULT");
                    intent.setData(Uri.parse(String.format("package:%s", getApplicationContext().getPackageName())));
                    startActivityForResult(intent, MANAGE_APP_ALL_FILES_ACCESS_REQUEST_CODE);
                } catch (Exception e) {
                    Intent intent = new Intent();
                    intent.setAction(Settings.ACTION_MANAGE_ALL_FILES_ACCESS_PERMISSION);
                    startActivityForResult(intent, MANAGE_APP_ALL_FILES_ACCESS_REQUEST_CODE);
                }
            }
        } else {
            if (generalFunc.isCameraStoragePermissionGranted()) {
                openDocChoose();
            }
        }*/
        // TODO: 28-04-2021 / Viral | Android 11 (30) Store permission code remove | revert 29
        if (generalFunc.isCameraStoragePermissionGranted()) {
            openDocChoose();
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);

        switch (requestCode) {
            case GeneralFunctions.MY_PERMISSIONS_REQUEST: {
                if (generalFunc.isPermisionGranted()) {
                    selectImage();
                }
                break;

            }
        }
    }

    OpenProgressUpdateDialog openprogressDialog;

    private void ShowProgressUpdateDialog(int progress) {
        if (openprogressDialog == null) {
            Log.d(TAG, "onProgressUpdate: " + "dialognull");
            openprogressDialog = new OpenProgressUpdateDialog(getActContext(), generalFunc, uploadProfileImage);
            openprogressDialog.run();
        }
        openprogressDialog.updateProgress(progress);

    }

    private static final String TAG = "UploadDocActivity";


}
